using System;
using System.Collections.Generic;
using System.IO;

/**
 * Write a description of class Light here.
 * 
 * author Peter Dordal 
 */
public class Light : Item
{
    // instance variables - replace the example below with your own
    private bool is_On = false;

    /**
     * Constructor for objects of class Light
     */
    public Light(string desc, int weight) : base(desc, weight)
    {
    }

    public Light(string desc) : base(desc) {
    }

    public bool isOn ()
    {
        return is_On;
    }
    
    public void light() {
        is_On = true;
    }
    
    /** 
     * getLight looks on the given list of Items (usually the inventory)
     * to see if there's a Light object that is lit().
     * If so, the first such is returned.
     * If not, null is returned.
     * Note that getLight **must do run-time type checking**
     * (Well, the alternative is to add to Item an isLight method,
     * but that seems to be an AWKWARD use of the inheritance model)
     */
    public static Light getLight(List<Item> inv) {
        int i = 0;
        foreach (Item itm in inv) {
            // now for the dynamic part
            if (itm is Light) {
                Light lt = itm as Light;         // note (cast)
                if (lt.isOn()) return lt;
            }
        }
        return null;    // get here if not found
    }
    
    public static bool haslight(List<Item> inv) {
        return (getLight(inv) != null) ;
    }
}
